unit Barcod32;
interface
{$ifdef VER80}
  {If You have no Quickreports with Delphi-1 (by default),
   make the following line a comment (insert a dot before the $-sign),
   otherweise make it a "define" statement (remove the dot before the $-sign)}
  {.$define QUICKREPORT}
{$else}
  {$define QUICKREPORT} {Quickreports are always available with Delphi-2}
{$endif}

uses
  Wintypes,Winprocs,Classes,
{$ifdef VER80}
  Bar16LL, Bar16HL
{$else}
  Bar32LL, Bar32HL
{$endif}
{$ifdef QUICKREPORT}
  ,Quickrep
{$endif}
  ;

procedure Register;

type
  TBarcode=class(TCustomBarcode)
           end;

{$ifdef QUICKREPORT}

type
  TQRBarcode = class(TQRDBText) {TQRBarcode is derived from TQRDBText}
  private
    { Private-Deklarationen }
    Barcode:TCustomBarcode;
    procedure initbarcode;
    procedure SetInputcode(NewCode:String);
    function GetInputcode:String;
    procedure SetBTyp(NewTyp:btCodeTypes);
    function GetBTyp:btCodeTypes;
    procedure SetSCSize(NewSize:btCodeSizes);
    function GetSCSize:btCodeSizes;
    procedure SetHeightPercent(NewHeight:Integer);
    function GetHeightPercent:Integer;
    procedure SetReduceWidth(New:boolean);
    function GetReduceWidth:boolean;
    procedure SetHDCode(New:boolean);
    function GetHDCode:boolean;
    procedure SetZoomSize(New:boolean);
    function GetZoomSize:boolean;
    function GetBarcodeCaption:string;
  public
    { Public-Deklarationen }
    constructor Create(AOwner: TComponent);
    procedure Print(X,Y : Integer); override;
    procedure Paint;override;
    procedure invalidate;override;
  published
    { Published-Deklarationen }
    property Bar_Caption:string read GetInputcode write SetInputcode;
    property Bar_CodeType: btCodeTypes read GetbTyp write SetbTyp default EAN_8;
    property Bar_HeightPercent:Integer read GetHeightPercent write SetHeightPercent default 100;
    {with quickreports "Bar_HighDensity" makes no sense, next line is commented out}
    {property Bar_HighDensity:Boolean read GetHDCode write SetHDCode;}
    property Bar_ModuleWidth: btCodeSizes read GetSCSize write SetSCSize default SC0;
    {with quickreports "Bar_WidthReduce" makes no sense, next line is commented out}
    {property Bar_WidthReduce:Boolean read GetReduceWidth write SetReduceWidth;}
    {with quickreports "Bar_Zoomsize" makes no sense, next line is commented out}
    {property Bar_ZoomSize:Boolean read GetZoomSize write SetZoomSize;}
  end;
{$endif}

implementation

{Include resource file with license information}
{$ifdef VER80}
  {$R BARCOD16.RES}
{$else}
  {$R BARCOD32.RES}
{$endif}


{$ifdef QUICKREPORT}
procedure TQRBarcode.initbarcode;
begin
  Barcode:=TCustomBarcode.create(self);
end;


constructor TQRBarcode.Create(AOwner: TComponent);
begin
  inherited create(AOwner);
  if Barcode=nil then initbarcode;
end;


procedure TQRBarcode.invalidate;
var
  r:TRect;
begin
  inherited invalidate;
  if barcode<>nil then
  begin
    r.top:=top;r.left:=left;
    r.right:=r.left+width;
    r.bottom:=r.top+height;
    invalidaterect(parent.handle,@r,true);
  end;
end;

procedure TQRBarcode.SetInputcode(NewCode:String);
begin
  if Barcode=nil then initbarcode;
  Barcode.setinputcode(NewCode);
  invalidate;
end;

function TQRBarcode.GetInputcode:String;
begin
  if Barcode=nil then initbarcode;
  Getinputcode:=Barcode.Getinputcode;
end;

procedure TQRBarcode.SetBTyp(NewTyp:btCodeTypes);
begin
  if Barcode=nil then initbarcode;
  barcode.SetBTyp(NewTyp);
  invalidate;
end;

function TQRBarcode.GetBTyp:btCodeTypes;
begin
  if Barcode=nil then initbarcode;
  GetBTyp:=btCodeTypes(Barcode.GetBTyp);
end;

procedure TQRBarcode.SetSCSize(NewSize:btCodeSizes);
begin
  if Barcode=nil then initbarcode;
  barcode.SetSCSize(NewSize);
  invalidate;
end;

function TQRBarcode.GetSCSize:btCodeSizes;
begin
  if Barcode=nil then initbarcode;
  GetSCSize:=btCodeSizes(Barcode.GetSCSize);
end;

procedure TQRBarcode.SetHeightPercent(NewHeight:Integer);
begin
  if Barcode=nil then initbarcode;
  Barcode.SetHeightPercent(NewHeight);
  invalidate;
end;

function TQRBarcode.GetHeightPercent:Integer;
begin
  if Barcode=nil then initbarcode;
  GetHeightPercent:=barcode.getheightPercent;
end;

procedure TQRBarcode.SetReduceWidth(New:boolean);
begin
  if Barcode=nil then initbarcode;
  Barcode.SetReduceWidth(New);
  invalidate;
end;

function TQRBarcode.GetReduceWidth:boolean;
begin
  if Barcode=nil then initbarcode;
  GetReduceWidth:=Barcode.GetReduceWidth;
end;

procedure TQRBarcode.SetHDCode(New:boolean);
begin
  if Barcode=nil then initbarcode;
  Barcode.SetHDCode(New);
  invalidate;
end;

function TQRBarcode.GetHDCode:boolean;
begin
  if Barcode=nil then initbarcode;
  GetHDCode:=Barcode.GetHDCode;
end;

procedure TQRBarcode.SetZoomSize(New:boolean);
begin
  if Barcode=nil then initbarcode;
  Barcode.SetZoomSize(New);
  invalidate;
end;

function TQRBarcode.GetZoomSize:boolean;
begin
  if Barcode=nil then initbarcode;
  GetZoomsize:=BArcode.Getzoomsize;
end;


function TQRBarcode.GetBarcodeCaption: string;
{If "Datasource" and "Datafield" are assigned, get the
 code string from the datafield and otherwise from "Bar_Caption"}
begin
  if (FDataLink<>nil) and (FDataLink.Field <> nil) then
    GetBarcodeCaption := FDataLink.Field.DisplayText
  else
    GetBarcodeCaption := Bar_Caption;
end;


procedure TQRBarcode.Paint;
var
  mypoint:TPoint;
begin
  if Barcode=nil then initbarcode;
  if self.canvas<>nil then
  begin
    if Bar_Caption<>GetBarcodeCaption then Bar_Caption:=GetBarcodeCaption;
    Barcode.print(self.canvas,0,0,@mypoint);
    Width:=mypoint.x;
    Height:=mypoint.y;
  end;
end;

procedure TQRBarcode.Print(X,Y : Integer);
var value:string;
    p:TPoint;
begin
  if Barcode=nil then initbarcode;
  value:=GetBarcodeCaption;    {Get current Bar_caption or Datafield}
{$ifdef VER80}
  try  {Try some user defined actions}
    OnPrint(self,value);
  except {catch exception if OnPrint is not assigned}
  end;
{$else}
  if assigned(OnPrint) then  {If OnPrint-method is assigned}
    OnPrint(self,value);     {Do some user defined actions}
{$endif}
  if bar_caption<>value then bar_caption:=value;
  Barcode.Print(QRPrinter.canvas,x+left,y+top,nil);
end;

{$endif}   {ifdef QUICKREPORT}


procedure Register;
begin
  RegisterComponents('Schlottke', [TBarcode]);
{$ifdef QUICKREPORT}
  RegisterComponents('Schlottke', [TQRBarcode]);
{$endif}
end;

end.
